diff -r c6dc5f666695 doc/interpreter/quad.txi
--- a/doc/interpreter/quad.txi	Tue Sep 14 02:38:25 2010 -0400
+++ b/doc/interpreter/quad.txi	Tue Sep 14 12:31:02 2010 +0100
@@ -42,6 +42,10 @@
 These are
 
 @table @code
+@item cquad
+Double-adaptive numerical integration based on Clenshaw-Curits
+quadrature rules.
+
 @item quad
 Numerical integration based on Gaussian quadrature.
 
@@ -63,6 +67,8 @@
 numerical integration using the trapezoidal method through the
 @code{cumtrapz} function.
 
+@DOCSTRING(cquad)
+
 @DOCSTRING(quad)
 
 @DOCSTRING(quad_options)
diff -r c6dc5f666695 scripts/general/dblquad.m
--- a/scripts/general/dblquad.m	Tue Sep 14 02:38:25 2010 -0400
+++ b/scripts/general/dblquad.m	Tue Sep 14 12:31:02 2010 +0100
@@ -29,7 +29,8 @@
 ##
 ## Additional arguments, are passed directly to @var{f}.  To use the default
 ## value for @var{tol} one may pass an empty matrix.
-## @seealso{triplequad, quad, quadv, quadl, quadgk, trapz}
+##
+## @seealso{triplequad, cquad, quad, quadv, quadl, quadgk, trapz}
 ## @end deftypefn
 
 function q = dblquad(f, xa, xb, ya, yb, tol, quadf, varargin) 
diff -r c6dc5f666695 scripts/general/quadgk.m
--- a/scripts/general/quadgk.m	Tue Sep 14 02:38:25 2010 -0400
+++ b/scripts/general/quadgk.m	Tue Sep 14 12:31:02 2010 +0100
@@ -112,7 +112,7 @@
 ## approximate bounds on the error in the integral @code{abs (@var{q} -
 ## @var{i})}, where @var{i} is the exact value of the integral.
 ##
-## @seealso{triplequad, dblquad, quad, quadl, quadv, trapz}
+## @seealso{cquad, quad, quadl, quadv, trapz, dblquad, triplequad}
 ## @end deftypefn
 
 function [q, err] = quadgk (f, a, b, varargin)
diff -r c6dc5f666695 scripts/general/quadl.m
--- a/scripts/general/quadl.m	Tue Sep 14 02:38:25 2010 -0400
+++ b/scripts/general/quadl.m	Tue Sep 14 12:31:02 2010 +0100
@@ -42,6 +42,7 @@
 ## Revisited}, BIT Vol. 40, No. 1, March 2000, pp. 84--101.
 ## @url{http://www.inf.ethz.ch/personal/gander/}
 ##
+## @seealso{cquad, quad, quadgk, quadv, trapz, dblquad, triplequad}
 ## @end deftypefn
 
 ##   Author: Walter Gautschi
diff -r c6dc5f666695 scripts/general/quadv.m
--- a/scripts/general/quadv.m	Tue Sep 14 02:38:25 2010 -0400
+++ b/scripts/general/quadv.m	Tue Sep 14 12:31:02 2010 +0100
@@ -39,7 +39,8 @@
 ## Additional arguments @var{p1}, etc., are passed directly to @var{f}.
 ## To use default values for @var{tol} and @var{trace}, one may pass
 ## empty matrices.
-## @seealso{triplequad, dblquad, quad, quadl, quadgk, trapz}
+##
+## @seealso{cquad, quad, quadgk, quadl, trapz, dblquad, triplequad}
 ## @end deftypefn
 
 function [q, fcnt] = quadv (f, a, b, tol, trace, varargin)
diff -r c6dc5f666695 scripts/general/trapz.m
--- a/scripts/general/trapz.m	Tue Sep 14 02:38:25 2010 -0400
+++ b/scripts/general/trapz.m	Tue Sep 14 12:31:02 2010 +0100
@@ -27,7 +27,7 @@
 ## equally spaced vector is assumed.  @code{trapz (@var{x}, @var{y})} 
 ## evaluates the integral with respect to @var{x}.
 ##  
-## @seealso{cumtrapz}
+## @seealso{cumtrapz, cquad, quad, quadgk, quadl, quadv, dblquad, triplequad}
 ## @end deftypefn
 
 ## Author:      Kai Habel <kai.habel@gmx.de>
diff -r c6dc5f666695 scripts/general/triplequad.m
--- a/scripts/general/triplequad.m	Tue Sep 14 02:38:25 2010 -0400
+++ b/scripts/general/triplequad.m	Tue Sep 14 12:31:02 2010 +0100
@@ -30,7 +30,8 @@
 ##
 ## Additional arguments, are passed directly to @var{f}.  To use the default
 ## value for @var{tol} one may pass an empty matrix.
-## @seealso{dblquad, quad, quadv, quadl, quadgk, trapz}
+##
+## @seealso{dblquad, cquad, quad, quadv, quadl, quadgk, trapz}
 ## @end deftypefn
 
 function Q = triplequad(f, xa, xb, ya, yb, za, zb, tol, quadf, varargin)
diff -r c6dc5f666695 src/DLD-FUNCTIONS/cquad.cc
--- a/src/DLD-FUNCTIONS/cquad.cc	Tue Sep 14 02:38:25 2010 -0400
+++ b/src/DLD-FUNCTIONS/cquad.cc	Tue Sep 14 12:31:02 2010 +0100
@@ -1477,12 +1477,12 @@
 @deftypefn {Function File} {[@var{int}, @var{err}, @var{nr_points}] =} cquad (@var{f}, @var{a}, @var{b}, @var{tol})\n\
 @deftypefnx {Function File} {[@var{int}, @var{err}, @var{nr_points}] =} cquad (@var{f}, @var{a}, @var{b}, @var{tol}, @var{sing})\n\
 Numerically evaluates an integral using the doubly-adaptive\n\
-quadrature described by P. Gonnet in @cite{\"Increasing the\n\
+quadrature described in @cite{P. Gonnet, \"Increasing the\n\
 Reliability of Adaptive Quadrature Using Explicit Interpolants\",\n\
-ACM Transactions on Mathematical Software, in Press, 2010}.\n\
-The algorithm uses Clenshaw-Curtis quadrature rules of increasing\n\
-degree in each interval and bisects the interval if either the\n\
-function does not appear to be smooth or a rule of maximum\n\
+ACM Transactions on Mathematical Software, Vol. 37, Issue 3, \n\
+Article Nr. 3, 2010}. The algorithm uses Clenshaw-Curtis quadrature\n\
+rules of increasing degree in each interval and bisects the interval if\n\
+either the function does not appear to be smooth or a rule of maximum\n\
 degree has been reached. The error estimate is computed from the\n\
 L2-norm of the difference between two successive interpolations\n\
 of the integrand over the nodes of the respective quadrature rules.\n\
@@ -1537,7 +1537,7 @@
 well-behaved integrand than other methods such as\n\
 @code{quadgk} or @code{trapz}.\n\
 \n\
-@seealso{triplequad, dblquad, quadgk, quadl, quadv, trapz}\n\
+@seealso{quad, quadgk, quadl, quadv, trapz, dblquad, triplequad}\n\
 @end deftypefn")
 {
 
diff -r c6dc5f666695 src/DLD-FUNCTIONS/quad.cc
--- a/src/DLD-FUNCTIONS/quad.cc	Tue Sep 14 02:38:25 2010 -0400
+++ b/src/DLD-FUNCTIONS/quad.cc	Tue Sep 14 12:31:02 2010 +0100
@@ -212,6 +212,8 @@
 \n\
 It should be noted that since @code{quad} is written in Fortran it\n\
 cannot be called recursively.\n\
+\n\
+@seealso{cquad, quadgk, quadl, quadv, trapz, dblquad, triplequad}\n\
 @end deftypefn")
 {
   octave_value_list retval;